//------------------------------------------------------------------
#property link      "www.forex-tsd.com" 
#property copyright "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern double Period1          =  32;
extern double Period2          =   5;
extern double Period3          =   5;
extern int    Price            = PRICE_CLOSE;
extern int    ColorOn          = 0;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;

double tsihuu[];
double tsihud[];
double tsi[];
double signal[];
double slope[];
double trend[];

//
//
//
//
//

string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
bool   calculateMa;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,tsihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tsihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tsi);
   SetIndexBuffer(3,slope);
   SetIndexBuffer(4,signal);
   SetIndexBuffer(5,trend);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      shortName = timeFrameToString(timeFrame)+" true strength index ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")";
      IndicatorShortName(shortName);   
   return(0);
}
int deinit() { return(0); }

//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tsihuu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
         double avg = iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1);
         double ava = iEma(iEma(MathAbs(priceDiff),Period1,i,2),Period2,i,3);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            signal[i] = iEma(tsi[i],Period3,i,4);

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
               if (tsi[i] > tsi[i+1]) slope[i] =  1;
               if (tsi[i] < tsi[i+1]) slope[i] = -1;
               if (ColorOn==2)
               {
                  if (tsi[i]>signal[i]) trend[i] =  1;
                  if (tsi[i]<signal[i]) trend[i] = -1;
               }
               else
               {
                  if (tsi[i] > 0) trend[i] =  1;
                  if (tsi[i] < 0) trend[i] = -1;
               }
       
               //
               //
               //
               //
               //
                                         
               if (ColorOn==1)
                  if (slope[i]==1)
                        { tsihuu[i] = High[i]; tsihud[i] = Low[i]; }
                  else  { tsihud[i] = High[i]; tsihuu[i] = Low[i]; }
               else                  
                  if (trend[i]==1)
                        { tsihuu[i] = High[i]; tsihud[i] = Low[i]; }
                  else  { tsihud[i] = High[i]; tsihuu[i] = Low[i]; }
      }
      manageAlerts();
      return(0);
   }   
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   Comment(limit);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,ColorOn,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,ColorOn,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         if (ColorOn==1)
            if (slope[i]==1)
                  { tsihuu[i] = High[i]; tsihud[i] = Low[i]; }
            else  { tsihud[i] = High[i]; tsihuu[i] = Low[i]; }
         else                  
            if (trend[i]==1)
                  { tsihuu[i] = High[i]; tsihud[i] = Low[i]; }
            else  { tsihud[i] = High[i]; tsihuu[i] = Low[i]; }
   }
   
   //
   //
   //
   //
   //

   return(0);
   
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}





//+----------------------------------------------------------------------------------------+
//|                                                                                        |
//+----------------------------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Blau ergodic tsi trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Blau ergodic tsi"),message);
             if (alertsSound)   PlaySound("alert2.wav");//*************
      }
}

//-------------------------------------------------------------------------------------------+
//
//-------------------------------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
